Plzip Manual
************

This manual is for Plzip (version 1.3-pre1, 25 November 2014).

   Copyright (C) 2009-2014 Antonio Diaz Diaz.

   This manual is free documentation: you have unlimited permission to
copy, distribute and modify it.

1 Introduction
**************

Plzip is a massively parallel (multi-threaded) lossless data compressor
based on the lzlib compression library, with a user interface similar to
the one of lzip, bzip2 or gzip.

   Plzip can compress/decompress large files on multiprocessor machines
much faster than lzip, at the cost of a slightly reduced compression
ratio (0.4 to 2 percent larger compressed files). Note that the number
of usable threads is limited by file size; on files larger than a few GB
plzip can use hundreds of processors, but on files of only a few MB
plzip is no faster than lzip (see Minimum file sizes).

   Plzip uses the lzip file format; the files produced by plzip are
fully compatible with lzip-1.4 or newer, and can be rescued with
lziprecover.

   The lzip file format is designed for data sharing and long-term
archiving, taking into account both data integrity and decoder
availability:

   * The lzip format provides very safe integrity checking and some data
     recovery means. The lziprecover program can repair bit-flip errors
     (one of the most common forms of data corruption) in lzip files,
     and provides data recovery capabilities, including error-checked
     merging of damaged copies of a file.

   * The lzip format is as simple as possible (but not simpler). The
     lzip manual provides the code of a simple decompressor along with
     a detailed explanation of how it works, so that with the only help
     of the lzip manual it would be possible for a digital
     archaeologist to extract the data from a lzip file long after
     quantum computers eventually render LZMA obsolete.

   * Additionally the lzip reference implementation is copylefted, which
     guarantees that it will remain free forever.

   A nice feature of the lzip format is that a corrupt byte is easier to
repair the nearer it is from the beginning of the file. Therefore, with
the help of lziprecover, losing an entire archive just because of a
corrupt byte near the beginning is a thing of the past.

   Plzip uses the same well-defined exit status values used by lzip and
bzip2, which makes it safer than compressors returning ambiguous warning
values (like gzip) when it is used as a back end for other programs like
tar or zutils.

   Plzip will automatically use the smallest possible dictionary size
for each file without exceeding the given limit. Keep in mind that the
decompression memory requirement is affected at compression time by the
choice of dictionary size limit (see Memory requirements).

   When compressing, plzip replaces every file given in the command line
with a compressed version of itself, with the name "original_name.lz".
When decompressing, plzip attempts to guess the name for the
decompressed file from that of the compressed file as follows:

filename.lz    becomes   filename
filename.tlz   becomes   filename.tar
anyothername   becomes   anyothername.out

   (De)compressing a file is much like copying or moving it; therefore
plzip preserves the access and modification dates, permissions, and,
when possible, ownership of the file just as "cp -p" does. (If the user
ID or the group ID can't be duplicated, the file permission bits
S_ISUID and S_ISGID are cleared).

   Plzip is able to read from some types of non regular files if the
'--stdout' option is specified.

   If no file names are specified, plzip compresses (or decompresses)
from standard input to standard output. In this case, plzip will
decline to write compressed output to a terminal, as this would be
entirely incomprehensible and therefore pointless.

   Plzip will correctly decompress a file which is the concatenation of
two or more compressed files. The result is the concatenation of the
corresponding uncompressed files. Integrity testing of concatenated
compressed files is also supported.

   WARNING! Even if plzip is bug-free, other causes may result in a
corrupt compressed file (bugs in the system libraries, memory errors,
etc).  Therefore, if the data you are going to compress is important,
give the '--keep' option to plzip and do not remove the original file
until you verify the compressed file with a command like
'plzip -cd file.lz | cmp file -'.

2 Program design
****************

When compressing, plzip divides the input file into chunks and
compresses as many chunks simultaneously as worker threads are chosen,
creating a multi-member compressed file.

   When decompressing, plzip decompresses as many members
simultaneously as worker threads are chosen. Files that were compressed
with lzip will not be decompressed faster than using lzip (unless the
'-b' option was used) because lzip usually produces single-member
files, which can't be decompressed in parallel.

   For each input file, a splitter thread and several worker threads are
created, acting the main thread as muxer (multiplexer) thread. A "packet
courier" takes care of data transfers among threads and limits the
maximum number of data blocks (packets) being processed simultaneously.

   The splitter reads data blocks from the input file, and distributes
them to the workers. The workers (de)compress the blocks received from
the splitter. The muxer collects processed packets from the workers, and
writes them to the output file.

   When decompressing from a regular file, the splitter is removed and
the workers read directly from the input file. If the output file is
also a regular file, the muxer is also removed and the workers write
directly to the output file. With these optimizations, the use of RAM
is greatly reduced and the decompression speed of large files with many
members is only limited by the number of processors available and by
I/O speed.

3 Invoking plzip
****************

The format for running plzip is:

     plzip [OPTIONS] [FILES]

   Plzip supports the following options:

'-h'
'--help'
     Print an informative help message describing the options and exit.

'-V'
'--version'
     Print the version number of plzip on the standard output and exit.

'-B BYTES'
'--data-size=BYTES'
     Set the size of the input data blocks, in bytes. The input file
     will be divided in chunks of this size before compression is
     performed. Valid values range from 8 KiB to 1 GiB. Default value
     is two times the dictionary size. Plzip will reduce the dictionary
     size if it is larger than the chosen data size.

'-c'
'--stdout'
     Compress or decompress to standard output. Needed when reading
     from a named pipe (fifo) or from a device.

'-d'
'--decompress'
     Decompress.

'-f'
'--force'
     Force overwrite of output files.

'-F'
'--recompress'
     Force recompression of files whose name already has the '.lz' or
     '.tlz' suffix.

'-k'
'--keep'
     Keep (don't delete) input files during compression or
     decompression.

'-m BYTES'
'--match-length=BYTES'
     Set the match length limit in bytes. After a match this long is
     found, the search is finished. Valid values range from 5 to 273.
     Larger values usually give better compression ratios but longer
     compression times.

'-n N'
'--threads=N'
     Set the number of worker threads. Valid values range from 1 to "as
     many as your system can support". If this option is not used,
     plzip tries to detect the number of processors in the system and
     use it as default value. 'plzip --help' shows the system's default
     value.

     Note that the number of usable threads is limited to
     ceil( file_size / data_size ) during compression (see Minimum file sizes),
     and to the number of members in the input during
     decompression.

'-o FILE'
'--output=FILE'
     When reading from standard input and '--stdout' has not been
     specified, use 'FILE' as the virtual name of the uncompressed
     file. This produces a file named 'FILE' when decompressing, and a
     file named 'FILE.lz' when compressing.

'-q'
'--quiet'
     Quiet operation. Suppress all messages.

'-s BYTES'
'--dictionary-size=BYTES'
     Set the dictionary size limit in bytes. Valid values range from 4
     KiB to 512 MiB. Plzip will use the smallest possible dictionary
     size for each file without exceeding this limit. Note that
     dictionary sizes are quantized. If the specified size does not
     match one of the valid sizes, it will be rounded upwards by adding
     up to (BYTES / 16) to it.

     For maximum compression you should use a dictionary size limit as
     large as possible, but keep in mind that the decompression memory
     requirement is affected at compression time by the choice of
     dictionary size limit.

'-t'
'--test'
     Check integrity of the specified file(s), but don't decompress
     them.  This really performs a trial decompression and throws away
     the result.  Use it together with '-v' to see information about
     the file.

'-v'
'--verbose'
     Verbose mode.
     When compressing, show the compression ratio for each file
     processed. A second '-v' shows the progress of compression.
     When decompressing or testing, further -v's (up to 4) increase the
     verbosity level, showing status, compression ratio, dictionary
     size, decompressed size, and compressed size.

'-1 .. -9'
     Set the compression parameters (dictionary size and match length
     limit) as shown in the table below. Note that '-9' can be much
     slower than '-1'. These options have no effect when decompressing.

     The bidimensional parameter space of LZMA can't be mapped to a
     linear scale optimal for all files. If your files are large, very
     repetitive, etc, you may need to use the '--match-length' and
     '--dictionary-size' options directly to achieve optimal
     performance.

     Level   Dictionary size   Match length limit
     -1      1 MiB             5 bytes
     -2      1.5 MiB           6 bytes
     -3      2 MiB             8 bytes
     -4      3 MiB             12 bytes
     -5      4 MiB             20 bytes
     -6      8 MiB             36 bytes
     -7      16 MiB            68 bytes
     -8      24 MiB            132 bytes
     -9      32 MiB            273 bytes

'--fast'
'--best'
     Aliases for GNU gzip compatibility.

   Numbers given as arguments to options may be followed by a multiplier
and an optional 'B' for "byte".

   Table of SI and binary prefixes (unit multipliers):

Prefix   Value                     |   Prefix   Value
k        kilobyte  (10^3 = 1000)   |   Ki       kibibyte (2^10 = 1024)
M        megabyte  (10^6)          |   Mi       mebibyte (2^20)
G        gigabyte  (10^9)          |   Gi       gibibyte (2^30)
T        terabyte  (10^12)         |   Ti       tebibyte (2^40)
P        petabyte  (10^15)         |   Pi       pebibyte (2^50)
E        exabyte   (10^18)         |   Ei       exbibyte (2^60)
Z        zettabyte (10^21)         |   Zi       zebibyte (2^70)
Y        yottabyte (10^24)         |   Yi       yobibyte (2^80)

   Exit status: 0 for a normal exit, 1 for environmental problems (file
not found, invalid flags, I/O errors, etc), 2 to indicate a corrupt or
invalid input file, 3 for an internal consistency error (eg, bug) which
caused plzip to panic.

4 File format
*************

Perfection is reached, not when there is no longer anything to add, but
when there is no longer anything to take away.
-- Antoine de Saint-Exupery

   In the diagram below, a box like this:
+---+
|   | <-- the vertical bars might be missing
+---+

   represents one byte; a box like this:
+==============+
|              |
+==============+

   represents a variable number of bytes.

   A lzip file consists of a series of "members" (compressed data sets).
The members simply appear one after another in the file, with no
additional information before, between, or after them.

   Each member has the following structure:
+--+--+--+--+----+----+=============+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| ID string | VN | DS | Lzma stream | CRC32 |   Data size   |  Member size  |
+--+--+--+--+----+----+=============+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   All multibyte values are stored in little endian order.

'ID string'
     A four byte string, identifying the lzip format, with the value
     "LZIP" (0x4C, 0x5A, 0x49, 0x50).

'VN (version number, 1 byte)'
     Just in case something needs to be modified in the future. 1 for
     now.

'DS (coded dictionary size, 1 byte)'
     Lzip divides the distance between any two powers of 2 into 8
     equally spaced intervals, named "wedges". The dictionary size is
     calculated by taking a power of 2 (the base size) and substracting
     from it a number of wedges between 0 and 7. The size of a wedge is
     (base_size / 16).
     Bits 4-0 contain the base 2 logarithm of the base size (12 to 29).
     Bits 7-5 contain the number of wedges (0 to 7) to substract from
     the base size to obtain the dictionary size.
     Example: 0xD3 = 2^19 - 6 * 2^15 = 512 KiB - 6 * 32 KiB = 320 KiB
     Valid values for dictionary size range from 4 KiB to 512 MiB.

'Lzma stream'
     The lzma stream, finished by an end of stream marker. Uses default
     values for encoder properties. See the lzip manual for a full
     description.

'CRC32 (4 bytes)'
     CRC of the uncompressed original data.

'Data size (8 bytes)'
     Size of the uncompressed original data.

'Member size (8 bytes)'
     Total size of the member, including header and trailer. This field
     acts as a distributed index, allows the verification of stream
     integrity, and facilitates safe recovery of undamaged members from
     multi-member files.

5 Memory required to compress and decompress
********************************************

The amount of memory required *per thread* is approximately the
following:

   * For compression; 11 times the dictionary size plus 3 times the
     data size (see --data-size).

   * For decompression of a regular (seekable) file to another regular
     file, or for testing of a regular file; the dictionary size. Note
     that regular files with more than 1024 bytes of trailing garbage
     are treated as non-seekable.

   * For testing of a non-seekable file or of standard input; the
     dictionary size plus up to 5 MiB.

   * For decompression of a regular file to a non-seekable file or to
     standard output; the dictionary size plus up to 32 MiB.

   * For decompression of a non-seekable file or of standard input; the
     dictionary size plus up to 35 MiB.

6 Minimum file sizes required for full compression speed
********************************************************

When compressing, plzip divides the input file into chunks and
compresses as many chunks simultaneously as worker threads are chosen,
creating a multi-member compressed file.

   For this to work as expected (and roughly multiply the compression
speed by the number of available processors), the uncompressed file
must be at least as large as the number of worker threads times the
chunk size (see --data-size). Else some processors will not get any
data to compress, and compression will be proportionally slower. The
maximum speed increase achievable on a given file is limited by the
ratio (file_size / data_size).

   The following table shows the minimum uncompressed file size needed
for full use of N processors at a given compression level, using the
default data size for each level:

Processors   2         3         4         8         16        64
-------------------------------------------------------------------------
Level
-1           4 MiB     6 MiB     8 MiB     16 MiB    32 MiB    128 MiB
-2           6 MiB     9 MiB     12 MiB    24 MiB    48 MiB    192 MiB
-3           8 MiB     12 MiB    16 MiB    32 MiB    64 MiB    256 MiB
-4           12 MiB    18 MiB    24 MiB    48 MiB    96 MiB    384 MiB
-5           16 MiB    24 MiB    32 MiB    64 MiB    128 MiB   512 MiB
-6           32 MiB    48 MiB    64 MiB    128 MiB   256 MiB   1 GiB
-7           64 MiB    96 MiB    128 MiB   256 MiB   512 MiB   2 GiB
-8           96 MiB    144 MiB   192 MiB   384 MiB   768 MiB   3 GiB
-9           128 MiB   192 MiB   256 MiB   512 MiB   1 GiB     4 GiB

7 Reporting bugs
****************

There are probably bugs in plzip. There are certainly errors and
omissions in this manual. If you report them, they will get fixed. If
you don't, no one will ever know about them and they will remain unfixed
for all eternity, if not longer.

   If you find a bug in plzip, please send electronic mail to
<lzip-bug@nongnu.org>. Include the version number, which you can find
by running 'plzip --version'.